gtkmm 3.6.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gtk::TextBuffer Class Reference
TextView Classes

Multi-line attributed text that can be displayed by one or more Gtk::TextView widgets. More...

Inheritance diagram for Gtk::TextBuffer:
[legend]

List of all members.

## Public Types

typedef TextIter | iterator
typedef TextTag | Tag
typedef TextTagTable | TagTable
typedef TextMark | Mark
typedef TextChildAnchor | ChildAnchor
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Public Member Functions

virtual | ~TextBuffer ()
GtkTextBuffer* | gobj ()
| Provides access to the underlying C GObject.
const GtkTextBuffer* | gobj () const
| Provides access to the underlying C GObject.
GtkTextBuffer* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_line_count () const
| Obtains the number of lines in the buffer.
int | get_char_count () const
| Gets the number of characters in the buffer; note that characters and bytes are not the same, you can't e.g. expect the contents of the buffer in string form to be this many bytes long.
int | size () const
| See get_char_count().
Glib::RefPtr < TextBuffer::TagTable > | get_tag_table ()
| Get the Gtk::TextTagTable associated with this buffer.
Glib::RefPtr< const TextBuffer::TagTable > | get_tag_table () const
| Get the Gtk::TextTagTable associated with this buffer.
void | set_text (const Glib::ustring& text)
| Removes the current contents of the buffer, and inserts text instead.
void | set_text (const char* text_begin, const char* text_end)
| Removes the current contents of the buffer, and inserts text instead.
iterator | insert (const iterator& pos, const Glib::ustring& text)
| Inserts text at position pos.
iterator | insert (const iterator& pos, const char* text_begin, const char* text_end)
| Inserts text at position pos.
void | insert_at_cursor (const Glib::ustring& text)
| Inserts text, using the current cursor position as the insertion point.
void | insert_at_cursor (const char* text_begin, const char* text_end)
| Inserts text, using the current cursor position as the insertion point.
std::pair< iterator, bool > | insert_interactive (const iterator& pos, const Glib::ustring& text, bool default_editable=true)
| Like insert(), but the insertion will not occur if iter is at a non-editable location in the buffer.
std::pair< iterator, bool > | insert_interactive (const iterator& pos, const char* text_begin, const char* text_end, bool default_editable=true)
| Like insert(), but the insertion will not occur if pos is at a non-editable location in the buffer.
bool | insert_interactive_at_cursor (const Glib::ustring& text, bool default_editable=true)
| Calls insert_interactive() at the cursor position.
bool | insert_interactive_at_cursor (const char* text_begin, const char* text_end, bool default_editable=true)
| Calls insert_interactive() at the cursor position.
iterator | insert (const iterator& pos, const iterator& range_begin, const iterator& range_end)
| Copies text, tags, and pixbufs between range_begin and range_end (the order of range_begin and range_begin doesn't matter) and inserts the copy at pos.
std::pair< iterator, bool > | insert_interactive (const iterator& pos, const iterator& range_begin, const iterator& range_end, bool default_editable=true)
| Same as insert_range(), but does nothing if the insertion point isn't editable.
iterator | insert_with_tag (const iterator& pos, const Glib::ustring& text, const Glib::RefPtr< Tag >& tag)
iterator | insert_with_tag (const iterator& pos, const char* text_begin, const char* text_end, const Glib::RefPtr< Tag >& tag)
iterator | insert_with_tag (const iterator& pos, const Glib::ustring& text, const Glib::ustring& tag_name)
iterator | insert_with_tag (const iterator& pos, const char* text_begin, const char* text_end, const Glib::ustring& tag_name)
iterator | insert_with_tags (const iterator& pos, const Glib::ustring& text, const std::vector< Glib::RefPtr< Tag > >& tags)
| Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.
iterator | insert_with_tags (const iterator& pos, const char* text_begin, const char* text_end, const std::vector< Glib::RefPtr< Tag > >& tags)
| Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.
iterator | insert_with_tags_by_name (const iterator& pos, const Glib::ustring& text, const std::vector< Glib::ustring >& tag_names)
| Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.
iterator | insert_with_tags_by_name (const iterator& pos, const char* text_begin, const char* text_end, const std::vector< Glib::ustring >& tag_names)
| Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.
iterator | erase (const iterator& range_begin, const iterator& range_end)
std::pair< iterator, bool > | erase_interactive (const iterator& range_begin, const iterator& range_end, bool default_editable=true)
iterator | backspace (const iterator& iter, bool interactive=true, bool default_editable=true)
| Performs the appropriate action as if the user hit the delete key with the cursor at the position specified by iter.
Glib::ustring | get_text (const iterator& start, const iterator&end, bool include_hidden_chars=true) const
| Returns the text in the range [ start, end).
Glib::ustring | get_text (bool include_hidden_chars=true) const
| Returns all the text in the buffer.
Glib::ustring | get_slice (const iterator& start, const iterator&end, bool include_hidden_chars=true) const
| Returns the text in the range [ start, end).
iterator | insert_pixbuf (const iterator& pos, const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
iterator | insert_child_anchor (const iterator& pos, const Glib::RefPtr< ChildAnchor >& anchor)
Glib::RefPtr< ChildAnchor > | create_child_anchor (const iterator& pos)
void | add_mark (const Glib::RefPtr< TextBuffer::Mark >& mark, const iterator& where)
| Adds the mark at position where.
Glib::RefPtr< TextBuffer::Mark > | create_mark (const Glib::ustring& mark_name, const iterator& where, bool left_gravity=true)
| Creates a mark at position where.
Glib::RefPtr< Mark > | create_mark (const iterator& where, bool left_gravity=true)
| Create an anonymous mark.
void | move_mark (const Glib::RefPtr< Mark >& mark, const iterator& where)
| Moves mark to the new location where.
void | delete_mark (const Glib::RefPtr< Mark >& mark)
| Deletes mark, so that it's no longer located anywhere in the buffer.
Glib::RefPtr< TextBuffer::Mark > | get_mark (const Glib::ustring& name)
| Returns the mark named name in buffer buffer, or `0` if no such mark exists in the buffer.
Glib::RefPtr< const TextBuffer::Mark > | get_mark (const Glib::ustring& name) const
| Returns the mark named name in buffer buffer, or `0` if no such mark exists in the buffer.
void | move_mark_by_name (const Glib::ustring& name, const iterator& where)
| Moves the mark named name (which must exist) to location where.
void | delete_mark_by_name (const Glib::ustring& name)
| Deletes the mark named name; the mark must exist.
Glib::RefPtr< TextBuffer::Mark > | get_insert ()
| Returns the mark that represents the cursor (insertion point).
Glib::RefPtr< TextBuffer::Mark > | get_selection_bound ()
| Returns the mark that represents the selection bound.
void | place_cursor (const iterator& where)
| This function moves the "insert" and "selection_bound" marks simultaneously.
void | apply_tag (const Glib::RefPtr< Tag >& tag, const iterator& start, const iterator&end)
| Emits the "apply-tag" signal on buffer.
void | remove_tag (const Glib::RefPtr< Tag >& tag, const iterator& start, const iterator&end)
| Emits the "remove-tag" signal.
void | apply_tag_by_name (const Glib::ustring& name, const iterator& start, const iterator&end)
| Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls apply_tag().
void | remove_tag_by_name (const Glib::ustring& name, const iterator& start, const iterator&end)
| Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls remove_tag().
void | remove_all_tags (const iterator& start, const iterator&end)
| Removes all tags in the range between start and end.
Glib::RefPtr< Tag > | create_tag (const Glib::ustring& tag_name)
| Creates a tag and adds it to the tag table for buffer.
Glib::RefPtr< Tag > | create_tag ()
| Creates an anoymous tag and adds it to the tag table for buffer.
iterator | get_iter_at_line_offset (int line_number, int char_offset)
iterator | get_iter_at_line_index (int line_number, int byte_index)
iterator | get_iter_at_offset (int char_offset)
iterator | get_iter_at_line (int line_number)
iterator | begin ()
iterator | end ()
void | get_bounds (iterator& range_begin, iterator& range_end)
iterator | get_iter_at_mark (const Glib::RefPtr< Mark >& mark)
| Get the current position of a mark.
iterator | get_iter_at_child_anchor (const Glib::RefPtr< ChildAnchor >& anchor)
| Get the current position of an anchor.
bool | get_modified () const
| Indicates whether the buffer has been modified since the last call to set_modified() set the modification flag to `false`.
void | set_modified (bool setting=true)
| Used to keep track of whether the buffer has been modified since the last time it was saved.
bool | get_has_selection () const
| Indicates whether the buffer has some text currently selected.
void | add_selection_clipboard (const Glib::RefPtr< Clipboard >& clipboard)
| Adds clipboard to the list of clipboards in which the selection contents of buffer are available.
void | remove_selection_clipboard (const Glib::RefPtr< Clipboard >& clipboard)
| Removes a Gtk::Clipboard added with add_selection_clipboard().
void | cut_clipboard (const Glib::RefPtr< Clipboard >& clipboard, bool default_editable=true)
| Copies the currently-selected text to a clipboard, then deletes said text if it's editable.
void | copy_clipboard (const Glib::RefPtr< Clipboard >& clipboard)
| Copies the currently-selected text to a clipboard.
void | paste_clipboard (const Glib::RefPtr< Clipboard >& clipboard, const iterator& override_location, bool default_editable=true)
void | paste_clipboard (const Glib::RefPtr< Clipboard >& clipboard, bool default_editable=true)
bool | get_selection_bounds (iterator& start, iterator&end) const
| Returns `true` if some text is selected; places the bounds of the selection in start and end (if the selection has length 0, then start and end are filled in with the same value).
bool | erase_selection (bool interactive=true, bool default_editable=true)
| Deletes the range between the "insert" and "selection_bound" marks, that is, the currently-selected text.
void | select_range (const iterator& ins, const iterator& bound)
| This function moves the "insert" and "selection_bound" marks simultaneously.
void | begin_user_action ()
| Called to indicate that the buffer operations between here and a call to end_user_action() are part of a single user-visible operation.
void | end_user_action ()
| Should be paired with a call to begin_user_action().
Glib::RefPtr< TargetList > | get_copy_target_list () const
| This function returns the list of targets this text buffer can provide for copying and as DND source.
Glib::RefPtr< TargetList > | get_paste_target_list () const
| This function returns the list of targets this text buffer supports for pasting and as DND destination.
Glib::ustring | register_serialize_tagset (const Glib::ustring& tagset_name)
| This function registers GTK+'s internal rich text serialization format with the passed buffer.
Glib::ustring | register_deserialize_tagset (const Glib::ustring& tagset_name)
| This function registers GTK+'s internal rich text serialization format with the passed buffer.
void | unregister_serialize_format (const Glib::ustring& format)
| This function unregisters a rich text format that was previously registered using register_serialize_format() or register_serialize_tagset()
void | unregister_deserialize_format (const Glib::ustring& format)
| This function unregisters a rich text format that was previously registered using register_deserialize_format() or register_deserialize_tagset().
void | set_can_create_tags (const Glib::ustring& format, bool can_create_tags=true)
| Use this function to allow a rich text deserialization function to create new tags in the receiving buffer.
bool | get_can_create_tags (const Glib::ustring& format) const
| This functions returns the value set with deserialize_set_can_create_tags()
std::vector< Glib::ustring > | get_serialize_formats () const
std::vector< Glib::ustring > | get_deserialize_formats () const
Glib::SignalProxy3< void, const TextBuffer::iterator &, const Glib::ustring&, int > | signal_insert ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const Glib::RefPtr < Gdk::Pixbuf >& > | signal_insert_pixbuf ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const Glib::RefPtr < ChildAnchor >& > | signal_insert_child_anchor ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const TextBuffer::iterator& > | signal_erase ()
Glib::SignalProxy0< void > | signal_changed ()
Glib::SignalProxy0< void > | signal_modified_changed ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const Glib::RefPtr < TextBuffer::Mark >& > | signal_mark_set ()
Glib::SignalProxy1< void, const Glib::RefPtr < TextBuffer::Mark >& > | signal_mark_deleted ()
Glib::SignalProxy3< void, const Glib::RefPtr < TextBuffer::Tag >&, const TextBuffer::iterator&, const TextBuffer::iterator& > | signal_apply_tag ()
Glib::SignalProxy3< void, const Glib::RefPtr < TextBuffer::Tag >&, const TextBuffer::iterator&, const TextBuffer::iterator& > | signal_remove_tag ()
Glib::SignalProxy0< void > | signal_begin_user_action ()
Glib::SignalProxy0< void > | signal_end_user_action ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gtk::Clipboard >& > | signal_paste_done ()
Glib::PropertyProxy_ReadOnly < Glib::RefPtr < TextBuffer::TagTable > > | property_tag_table () const
| Text Tag Table.
Glib::PropertyProxy < Glib::ustring > | property_text ()
| Current text of the buffer.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_text () const
| Current text of the buffer.
Glib::PropertyProxy_ReadOnly < bool > | property_has_selection () const
| Whether the buffer has some text currently selected.
Glib::PropertyProxy_ReadOnly< int > | property_cursor_position () const
| The position of the insert mark (as offset from the beginning of the buffer).
Public Member Functions inherited from Glib::Object
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj_copy () const
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< TextBuffer > | create ()
static Glib::RefPtr< TextBuffer > | create (const Glib::RefPtr< TagTable >& tag_table)

## Protected Member Functions

| TextBuffer ()
| TextBuffer (const Glib::RefPtr< TagTable >& tag_table)
virtual void | on_insert (const TextBuffer::iterator& pos, const Glib::ustring& text, int bytes)
| This is a default handler for the signal signal_insert().
virtual void | on_insert_pixbuf (const TextBuffer::iterator& pos, const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| This is a default handler for the signal signal_insert_pixbuf().
virtual void | on_insert_child_anchor (const TextBuffer::iterator& pos, const Glib::RefPtr< ChildAnchor >& anchor)
| This is a default handler for the signal signal_insert_child_anchor().
virtual void | on_erase (const TextBuffer::iterator& start, const TextBuffer::iterator&end)
| This is a default handler for the signal signal_erase().
virtual void | on_changed ()
| This is a default handler for the signal signal_changed().
virtual void | on_modified_changed ()
| This is a default handler for the signal signal_modified_changed().
virtual void | on_mark_set (const TextBuffer::iterator& location, const Glib::RefPtr< TextBuffer::Mark >& mark)
| This is a default handler for the signal signal_mark_set().
virtual void | on_mark_deleted (const Glib::RefPtr< TextBuffer::Mark >& mark)
| This is a default handler for the signal signal_mark_deleted().
virtual void | on_apply_tag (const Glib::RefPtr< TextBuffer::Tag >& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)
| This is a default handler for the signal signal_apply_tag().
virtual void | on_remove_tag (const Glib::RefPtr< TextBuffer::Tag >& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)
| This is a default handler for the signal signal_remove_tag().
virtual void | on_begin_user_action ()
| This is a default handler for the signal signal_begin_user_action().
virtual void | on_end_user_action ()
| This is a default handler for the signal signal_end_user_action().
virtual void | on_paste_done (const Glib::RefPtr< Gtk::Clipboard >& clipboard)
| This is a default handler for the signal signal_paste_done().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
virtual | ~Object ()
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
virtual | ~ObjectBase ()=0
void | initialize (GObject *castitem)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gtk::TextBuffer > | wrap (GtkTextBuffer* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Multi-line attributed text that can be displayed by one or more Gtk::TextView widgets.

Text in a buffer can be marked with tags. A Gtk::TextBuffer::Tag is an attribute that can be applied to some range of text. For example, a tag might be called "bold" and make the text inside the tag bold. However, the tag concept is more general than that; tags don't have to affect appearance. They can instead affect the behavior of mouse and key presses, "lock" a range of text so the user can't edit it, or countless other things. A tag is represented by a Gtk::TextBuffer::Tag object. One Gtk::TextBuffer::Tag can be applied to any number of text ranges in any number of Gtk::TextBuffers.

Each tag is stored in a Gtk::TextBuffer::TagTable. A tag table defines a set of tags that can be used together. Each buffer has one tag table associated with it; only tags from that tag table can be used with the buffer. A single tag table can be shared between multiple buffers, however.

Most text manipulation is accomplished with iterators, represented by an iterator. The iterator can be used to navigate over characters, words, lines, and sentences.

But iterators can't be used to preserve positions across buffer modifications. To preserve a position, the Gtk::TextBuffer::Mark object is ideal. There are two marks built-in to GtkTextBuffer; these are named "insert" and "selection_bound" and refer to the insertion point and the boundary of the selection which is not the insertion point. If no text is selected, these two marks will be in the same position. You can manipulate what is selected and where the cursor appears by moving these marks around.

Text buffers always contain at least one line, but may be empty (that is, buffers can contain zero characters). The last line in the text buffer never ends in a line separator (such as newline); the other lines in the buffer always end in a line separator. Line separators count as characters when computing character counts and character offsets. Note that some Unicode line separators are represented with multiple bytes in UTF-8, and the two-character sequence "\r\n" is also considered a line separator.

## Member Typedef Documentation

typedef TextChildAnchor Gtk::TextBuffer::ChildAnchor

typedef TextIter Gtk::TextBuffer::iterator

typedef TextMark Gtk::TextBuffer::Mark

typedef TextTag Gtk::TextBuffer::Tag

typedef TextTagTable Gtk::TextBuffer::TagTable

## Constructor & Destructor Documentation

virtual Gtk::TextBuffer::~TextBuffer | ( |  | ) |

virtual

Gtk::TextBuffer::TextBuffer | ( |  | ) |

protected

Gtk::TextBuffer::TextBuffer | ( | const Glib::RefPtr< TagTable >& | tag_table | ) |

explicitprotected

## Member Function Documentation

void Gtk::TextBuffer::add_mark | ( | const Glib::RefPtr< TextBuffer::Mark >& | mark,
|  | const iterator& | where
| ) |  |

Adds the mark at position where.

The mark must not be added to another buffer, and if its name is not `0` then there must not be another mark in the buffer with the same name.

Emits the "mark-set" signal as notification of the mark's initial placement.

Since gtkmm 2.12:

Parameters:

  mark | The mark to add.
  where | Location to place mark.

void Gtk::TextBuffer::add_selection_clipboard | ( | const Glib::RefPtr< Clipboard >& | clipboard | ) |

Adds clipboard to the list of clipboards in which the selection contents of buffer are available.

In most cases, clipboard will be the Gtk::Clipboard of type Gdk::SELECTION_PRIMARY for a view of buffer.

Parameters:

  clipboard | A Gtk::Clipboard.

void Gtk::TextBuffer::apply_tag | ( | const Glib::RefPtr< Tag >& | tag,
|  | const iterator& | start,
|  | const iterator& | end
| ) |  |

Emits the "apply-tag" signal on buffer.

The default handler for the signal applies tag to the given range. start and end do not have to be in order.

Parameters:

  tag | A Gtk::TextTag.
  start | One bound of range to be tagged.
  end | Other bound of range to be tagged.

void Gtk::TextBuffer::apply_tag_by_name | ( | const Glib::ustring & | name,
|  | const iterator& | start,
|  | const iterator& | end
| ) |  |

Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls apply_tag().

Parameters:

  name | Name of a named Gtk::TextTag.
  start | One bound of range to be tagged.
  end | Other bound of range to be tagged.

iterator Gtk::TextBuffer::backspace | ( | const iterator& | iter,
|  | bool | interactive = `true`,
|  | bool | default_editable = `true`
| ) |  |

Performs the appropriate action as if the user hit the delete key with the cursor at the position specified by iter.

In the normal case a single character will be deleted, but when combining accents are involved, more than one character can be deleted, and when precomposed character and accent combinations are involved, less than one character will be deleted.

Because the buffer is modified, all outstanding iterators become invalid after calling this method; however, this method returns a valid iterator that points to the location where text was deleted.

Parameters:

  iter | A position in the buffer.
  interactive | Whether the deletion is caused by user interaction.
  default_editable | Whether the buffer is editable by default.

Returns:
  An iterator to the location where text was deleted, if the buffer was modified.

Since gtkmm 2.6:

iterator Gtk::TextBuffer::begin | ( |  | ) |

void Gtk::TextBuffer::begin_user_action | ( |  | ) |

Called to indicate that the buffer operations between here and a call to end_user_action() are part of a single user-visible operation.

The operations between begin_user_action() and end_user_action() can then be grouped when creating an undo stack. Gtk::TextBuffer maintains a count of calls to begin_user_action() that have not been closed with a call to end_user_action(), and emits the "begin-user-action" and "end-user-action" signals only for the outermost pair of calls. This allows you to build user actions from other user actions.

The "interactive" buffer mutation functions, such as insert_interactive(), automatically call begin/end user action around the buffer operations they perform, so there's no need to add extra calls if you user action consists solely of a single call to one of those functions.

void Gtk::TextBuffer::copy_clipboard | ( | const Glib::RefPtr< Clipboard >& | clipboard | ) |

Copies the currently-selected text to a clipboard.

Parameters:

  clipboard | The Gtk::Clipboard object to copy to.

static Glib::RefPtr<TextBuffer> Gtk::TextBuffer::create | ( |  | ) |

static

static Glib::RefPtr<TextBuffer> Gtk::TextBuffer::create | ( | const Glib::RefPtr< TagTable >& | tag_table | ) |

static

Glib::RefPtr<ChildAnchor> Gtk::TextBuffer::create_child_anchor | ( | const iterator& | pos | ) |

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::create_mark | ( | const Glib::ustring & | mark_name,
|  | const iterator& | where,
|  | bool | left_gravity = `true`
| ) |  |

Creates a mark at position where.

The mark can be retrieved by name using get_mark(). If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity ( left_gravity = `false`), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Emits the "mark_set" signal as notification of the mark's initial placement.

Parameters:

  mark_name | Name for mark, or `0`.
  where | Location to place mark.
  left_gravity | Whether the mark has left gravity.

Returns:
  The new Gtk::TextMark object.

Glib::RefPtr<Mark> Gtk::TextBuffer::create_mark | ( | const iterator& | where,
|  | bool | left_gravity = `true`
| ) |  |

Create an anonymous mark.

Creates an anonymous mark at position where.

If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity ( left_gravity = `false`), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Emits the "mark_set" signal as notification of the mark's initial placement.

Parameters:

  where | Location to place mark.
  left_gravity | Whether the mark has left gravity.

Returns:
  The new Gtk::TextMark object.

Glib::RefPtr<Tag> Gtk::TextBuffer::create_tag | ( | const Glib::ustring & | tag_name | ) |

Creates a tag and adds it to the tag table for buffer.

Equivalent to calling Gtk::TextBuffer::Tag::create() and then adding the tag to the buffer's tag table. A tag called tag_name must not already exist in the tag table for this buffer.

Parameters:

  tag_name | The name for the new tag.

Returns:
  The new tag.

Glib::RefPtr<Tag> Gtk::TextBuffer::create_tag | ( |  | ) |

Creates an anoymous tag and adds it to the tag table for buffer.

Equivalent to calling Gtk::TextBuffer::Tag::create() and then adding the tag to the buffer's tag table.

Returns:
  The new tag.

void Gtk::TextBuffer::cut_clipboard | ( | const Glib::RefPtr< Clipboard >& | clipboard,
|  | bool | default_editable = `true`
| ) |  |

Copies the currently-selected text to a clipboard, then deletes said text if it's editable.

Parameters:

  clipboard | The Gtk::Clipboard object to cut to.
  default_editable | Default editability of the buffer.

void Gtk::TextBuffer::delete_mark | ( | const Glib::RefPtr< Mark >& | mark | ) |

Deletes mark, so that it's no longer located anywhere in the buffer.

Removes the reference the buffer holds to the mark, so if you don't keep a Glib::RefPtr to the mark, it will be freed. Even if the mark isn't freed, most operations on mark become invalid. There is no way to undelete a mark. Gtk::TextMark::get_deleted() will return `true` after this function has been called on a mark; Gtk::TextMark::get_deleted() indicates that a mark no longer belongs to a buffer. The "mark_deleted" signal will be emitted as notification after the mark is deleted.

Parameters:

  mark | A Gtk::TextMark in buffer.

void Gtk::TextBuffer::delete_mark_by_name | ( | const Glib::ustring & | name | ) |

Deletes the mark named name; the mark must exist.

See delete_mark() for details.

Parameters:

  name | Name of a mark in buffer.

iterator Gtk::TextBuffer::end | ( |  | ) |

void Gtk::TextBuffer::end_user_action | ( |  | ) |

Should be paired with a call to begin_user_action().

See that function for a full explanation.

iterator Gtk::TextBuffer::erase | ( | const iterator& | range_begin,
|  | const iterator& | range_end
| ) |  |

std::pair<iterator,bool> Gtk::TextBuffer::erase_interactive | ( | const iterator& | range_begin,
|  | const iterator& | range_end,
|  | bool | default_editable = `true`
| ) |  |

bool Gtk::TextBuffer::erase_selection | ( | bool | interactive = `true`,
|  | bool | default_editable = `true`
| ) |  |

Deletes the range between the "insert" and "selection_bound" marks, that is, the currently-selected text.

If interactive is `true`, the editability of the selection will be considered (users can't delete uneditable text).

Parameters:

  interactive | Whether the deletion is caused by user interaction.
  default_editable | Whether the buffer is editable by default.

Returns:
  Whether there was a non-empty selection to delete.

void Gtk::TextBuffer::get_bounds | ( | iterator& | range_begin,
|  | iterator& | range_end
| ) |  |

bool Gtk::TextBuffer::get_can_create_tags | ( | const Glib::ustring & | format | ) | const

This functions returns the value set with deserialize_set_can_create_tags()

Since gtkmm 2.10:

Parameters:

  format | A Gdk::Atom representing a registered rich text format.

Returns:
  Whether deserializing this format may create tags.

int Gtk::TextBuffer::get_char_count | ( |  | ) | const

Gets the number of characters in the buffer; note that characters and bytes are not the same, you can't e.g. expect the contents of the buffer in string form to be this many bytes long.

The character count is cached, so this function is very fast.

Returns:
  Number of characters in the buffer.

Glib::RefPtr<TargetList> Gtk::TextBuffer::get_copy_target_list | ( |  | ) | const

This function returns the list of targets this text buffer can provide for copying and as DND source.

The targets in the list are added with info values from the Gtk::TextBufferTargetInfo enum, using Gtk::TargetList::add_rich_text_targets() and Gtk::TargetList::add_text_targets().

Since gtkmm 2.10:

Returns:
  The Gtk::TargetList.

std::vector<Glib::ustring> Gtk::TextBuffer::get_deserialize_formats | ( |  | ) | const

bool Gtk::TextBuffer::get_has_selection | ( |  | ) | const

Indicates whether the buffer has some text currently selected.

Since gtkmm 2.10:

Returns:
  `true` if the there is text selected.

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::get_insert | ( |  | ) |

Returns the mark that represents the cursor (insertion point).

Equivalent to calling get_mark() to get the mark named "insert", but very slightly more efficient, and involves less typing.

Returns:
  Insertion point mark.

iterator Gtk::TextBuffer::get_iter_at_child_anchor | ( | const Glib::RefPtr< ChildAnchor >& | anchor | ) |

Get the current position of an anchor.

Parameters:

  anchor | A Gtk::TextBuffer::Anchor that appears in the buffer.

Returns:
  An iterator that points to the position of the anchor.

iterator Gtk::TextBuffer::get_iter_at_line | ( | int | line_number | ) |

iterator Gtk::TextBuffer::get_iter_at_line_index | ( | int | line_number,
|  | int | byte_index
| ) |  |

iterator Gtk::TextBuffer::get_iter_at_line_offset | ( | int | line_number,
|  | int | char_offset
| ) |  |

iterator Gtk::TextBuffer::get_iter_at_mark | ( | const Glib::RefPtr< Mark >& | mark | ) |

Get the current position of a mark.

Parameters:

  mark | The Gtk::TextBuffer::Mark

Returns:
  An iterator that points to the position of the mark.

iterator Gtk::TextBuffer::get_iter_at_offset | ( | int | char_offset | ) |

int Gtk::TextBuffer::get_line_count | ( |  | ) | const

Obtains the number of lines in the buffer.

This value is cached, so the function is very fast.

Returns:
  Number of lines in the buffer.

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::get_mark | ( | const Glib::ustring & | name | ) |

Returns the mark named name in buffer buffer, or `0` if no such mark exists in the buffer.

Parameters:

  name | A mark name.

Returns:
  A Gtk::TextMark, or `0`.

Glib::RefPtr<const TextBuffer::Mark> Gtk::TextBuffer::get_mark | ( | const Glib::ustring & | name | ) | const

Returns the mark named name in buffer buffer, or `0` if no such mark exists in the buffer.

Parameters:

  name | A mark name.

Returns:
  A Gtk::TextMark, or `0`.

bool Gtk::TextBuffer::get_modified | ( |  | ) | const

Indicates whether the buffer has been modified since the last call to set_modified() set the modification flag to `false`.

Used for example to enable a "save" function in a text editor.

Returns:
  `true` if the buffer has been modified.

Glib::RefPtr<TargetList> Gtk::TextBuffer::get_paste_target_list | ( |  | ) | const

This function returns the list of targets this text buffer supports for pasting and as DND destination.

The targets in the list are added with info values from the Gtk::TextBufferTargetInfo enum, using Gtk::TargetList::add_rich_text_targets() and Gtk::TargetList::add_text_targets().

Since gtkmm 2.10:

Returns:
  The Gtk::TargetList.

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::get_selection_bound | ( |  | ) |

Returns the mark that represents the selection bound.

Equivalent to calling get_mark() to get the mark named "selection_bound", but very slightly more efficient, and involves less typing.

The currently-selected text in buffer is the region between the "selection_bound" and "insert" marks. If "selection_bound" and "insert" are in the same place, then there is no current selection. get_selection_bounds() is another convenient function for handling the selection, if you just want to know whether there's a selection and what its bounds are.

Returns:
  Selection bound mark.

bool Gtk::TextBuffer::get_selection_bounds | ( | iterator& | start,
|  | iterator& | end
| ) |  | const

Returns `true` if some text is selected; places the bounds of the selection in start and end (if the selection has length 0, then start and end are filled in with the same value).

start and end will be in ascending order. If start and end are `0`, then they are not filled in, but the return value still indicates whether text is selected.

Parameters:

  start | Iterator to initialize with selection start.
  end | Iterator to initialize with selection end.

Returns:
  Whether the selection has nonzero length.

std::vector<Glib::ustring> Gtk::TextBuffer::get_serialize_formats | ( |  | ) | const

Glib::ustring Gtk::TextBuffer::get_slice | ( | const iterator& | start,
|  | const iterator& | end,
|  | bool | include_hidden_chars = `true`
| ) |  | const

Returns the text in the range [ start, end).

Excludes undisplayed text (text marked with tags that set the invisibility attribute) if include_hidden_chars is `false`. The returned string includes a 0xFFFC character whenever the buffer contains embedded images, so byte and character indexes into the returned string do correspond to byte and character indexes into the buffer. Contrast with get_text(). Note that 0xFFFC can occur in normal text as well, so it is not a reliable indicator that a pixbuf or widget is in the buffer.

Parameters:

  start | Start of a range.
  end | End of a range.
  include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

Glib::RefPtr<TextBuffer::TagTable> Gtk::TextBuffer::get_tag_table | ( |  | ) |

Get the Gtk::TextTagTable associated with this buffer.

Returns:
  The buffer's tag table.

Glib::RefPtr<const TextBuffer::TagTable> Gtk::TextBuffer::get_tag_table | ( |  | ) | const

Get the Gtk::TextTagTable associated with this buffer.

Returns:
  The buffer's tag table.

Glib::ustring Gtk::TextBuffer::get_text | ( | const iterator& | start,
|  | const iterator& | end,
|  | bool | include_hidden_chars = `true`
| ) |  | const

Returns the text in the range [ start, end).

Excludes undisplayed text (text marked with tags that set the invisibility attribute) if include_hidden_chars is `false`. Does not include characters representing embedded images, so byte and character indexes into the returned string do not correspond to byte and character indexes into the buffer. Contrast with get_slice().

Parameters:

  start | Start of a range.
  end | End of a range.
  include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

Glib::ustring Gtk::TextBuffer::get_text | ( | bool | include_hidden_chars = `true` | ) | const

Returns all the text in the buffer.

Excludes undisplayed text (text marked with tags that set the invisibility attribute) if include_hidden_chars is `false`. Does not include characters representing embedded images, so byte and character indexes into the returned string do not correspond to byte and character indexes into the buffer. Contrast with get_slice().

Parameters:

  include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

static GType Gtk::TextBuffer::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

GtkTextBuffer* Gtk::TextBuffer::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

Reimplemented from Glib::Object.

const GtkTextBuffer* Gtk::TextBuffer::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

Reimplemented from Glib::Object.

GtkTextBuffer* Gtk::TextBuffer::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

iterator Gtk::TextBuffer::insert | ( | const iterator& | pos,
|  | const Glib::ustring & | text
| ) |  |

Inserts text at position pos.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal. The pos iterator is invalidated when insertion occurs (because the buffer contents change).

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text | The text to be inserted in the buffer.

Returns:
  An iterator that points to the end of the inserted text.

iterator Gtk::TextBuffer::insert | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end
| ) |  |

Inserts text at position pos.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal. The pos iterator is invalidated when insertion occurs (because the buffer contents change).

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text_begin | The start of a UTF8 character array.
  text_end | The end of the UTF8 character array.

Returns:
  An iterator that points to the end of the inserted text.

iterator Gtk::TextBuffer::insert | ( | const iterator& | pos,
|  | const iterator& | range_begin,
|  | const iterator& | range_end
| ) |  |

Copies text, tags, and pixbufs between range_begin and range_end (the order of range_begin and range_begin doesn't matter) and inserts the copy at pos.

Used instead of simply getting/inserting text because it preserves images and tags. If range_begin and range_end are in a different buffer, the two buffers must share the same tag table.

Implemented via emissions of the insert_text and apply_tag signals, so expect those.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  range_begin | A position in a buffer.
  range_end | Another position in the same buffer as range_begin.

Returns:
  Whether text was actually inserted

void Gtk::TextBuffer::insert_at_cursor | ( | const Glib::ustring & | text | ) |

Inserts text, using the current cursor position as the insertion point.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal.

Parameters:

  text | The text to be inserted in the buffer.

Returns:
  An iterator that points to the end of the inserted text.

void Gtk::TextBuffer::insert_at_cursor | ( | const char * | text_begin,
|  | const char * | text_end
| ) |  |

Inserts text, using the current cursor position as the insertion point.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal.

Parameters:

  text_begin | The start of a UTF8 character array.
  text_end | The end of the UTF8 character array.

Returns:
  An iterator that points to the end of the inserted text.

iterator Gtk::TextBuffer::insert_child_anchor | ( | const iterator& | pos,
|  | const Glib::RefPtr< ChildAnchor >& | anchor
| ) |  |

std::pair<iterator,bool> Gtk::TextBuffer::insert_interactive | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | bool | default_editable = `true`
| ) |  |

Like insert(), but the insertion will not occur if iter is at a non-editable location in the buffer.

Usually you want to prevent insertions at ineditable locations if the insertion results from a user action (is interactive).

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text | The text to be inserted in the buffer.
  default_editable | Default editability of buffer

Returns:
  Whether text was actually inserted

std::pair<iterator,bool> Gtk::TextBuffer::insert_interactive | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | bool | default_editable = `true`
| ) |  |

Like insert(), but the insertion will not occur if pos is at a non-editable location in the buffer.

Usually you want to prevent insertions at ineditable locations if the insertion results from a user action (is interactive).

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text_begin | The start of a UTF8 character array.
  text_end | The end of the UTF8 character array.
  default_editable | Default editability of buffer.

Returns:
  Whether text was actually inserted

std::pair<iterator,bool> Gtk::TextBuffer::insert_interactive | ( | const iterator& | pos,
|  | const iterator& | range_begin,
|  | const iterator& | range_end,
|  | bool | default_editable = `true`
| ) |  |

Same as insert_range(), but does nothing if the insertion point isn't editable.

The default_editable parameter indicates whether the text is editable at pos if no tags enclosing pos affect editability. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  range_begin | A position in a buffer.
  range_end | Another position in the same buffer as range_begin.
  default_editable | Default editability of buffer.

Returns:
  Whether text was actually inserted

bool Gtk::TextBuffer::insert_interactive_at_cursor | ( | const Glib::ustring & | text,
|  | bool | default_editable = `true`
| ) |  |

Calls insert_interactive() at the cursor position.

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  text | The text to be inserted in the buffer.
  default_editable | Default editability of buffer

Returns:
  Whether text was actually inserted

bool Gtk::TextBuffer::insert_interactive_at_cursor | ( | const char * | text_begin,
|  | const char * | text_end,
|  | bool | default_editable = `true`
| ) |  |

Calls insert_interactive() at the cursor position.

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  text_begin | The start of a UTF8 character array.
  text_end | The end of the UTF8 character array.
  default_editable | Default editability of buffer

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_pixbuf | ( | const iterator& | pos,
|  | const Glib::RefPtr< Gdk::Pixbuf >& | pixbuf
| ) |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const Glib::RefPtr< Tag >& | tag
| ) |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const Glib::RefPtr< Tag >& | tag
| ) |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const Glib::ustring & | tag_name
| ) |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const Glib::ustring & | tag_name
| ) |  |

iterator Gtk::TextBuffer::insert_with_tags | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const std::vector< Glib::RefPtr< Tag > >& | tags
| ) |  |

Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text | The text to be inserted in the buffer.
  tags | A standard C++ container of Gtk::TextBuffer::Tags.

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_with_tags | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const std::vector< Glib::RefPtr< Tag > >& | tags
| ) |  |

Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text_begin | The start of a UTF8 character array.
  text_end | The end of the UTF8 character array.
  tags | A standard C++ container of Gtk::TextBuffer::Tags.

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_with_tags_by_name | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const std::vector< Glib::ustring > & | tag_names
| ) |  |

Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text | The text to be inserted in the buffer.
  tag_names | A standard C++ container of tag names.

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_with_tags_by_name | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const std::vector< Glib::ustring > & | tag_names
| ) |  |

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  pos | An iterator pointing to the position at which the text should be inserted.
  text_begin | The start of a UTF8 character array.
  text_end | The end of the UTF8 character array.
  tag_names | A standard C++ container of tag names.

Returns:
  Whether text was actually inserted

void Gtk::TextBuffer::move_mark | ( | const Glib::RefPtr< Mark >& | mark,
|  | const iterator& | where
| ) |  |

Moves mark to the new location where.

Emits the "mark-set" signal as notification of the move.

Parameters:

  mark | A Gtk::TextMark.
  where | New location for mark in buffer.

void Gtk::TextBuffer::move_mark_by_name | ( | const Glib::ustring & | name,
|  | const iterator& | where
| ) |  |

Moves the mark named name (which must exist) to location where.

See move_mark() for details.

Parameters:

  name | Name of a mark.
  where | New location for mark.

virtual void Gtk::TextBuffer::on_apply_tag | ( | const Glib::RefPtr< TextBuffer::Tag >& | tag,
|  | const TextBuffer::iterator& | range_begin,
|  | const TextBuffer::iterator& | range_end
| ) |  |

protectedvirtual

This is a default handler for the signal signal_apply_tag().

virtual void Gtk::TextBuffer::on_begin_user_action | ( |  | ) |

protectedvirtual

This is a default handler for the signal signal_begin_user_action().

virtual void Gtk::TextBuffer::on_changed | ( |  | ) |

protectedvirtual

This is a default handler for the signal signal_changed().

virtual void Gtk::TextBuffer::on_end_user_action | ( |  | ) |

protectedvirtual

This is a default handler for the signal signal_end_user_action().

virtual void Gtk::TextBuffer::on_erase | ( | const TextBuffer::iterator& | start,
|  | const TextBuffer::iterator& | end
| ) |  |

protectedvirtual

This is a default handler for the signal signal_erase().

virtual void Gtk::TextBuffer::on_insert | ( | const TextBuffer::iterator& | pos,
|  | const Glib::ustring & | text,
|  | int | bytes
| ) |  |

protectedvirtual

This is a default handler for the signal signal_insert().

virtual void Gtk::TextBuffer::on_insert_child_anchor | ( | const TextBuffer::iterator& | pos,
|  | const Glib::RefPtr< ChildAnchor >& | anchor
| ) |  |

protectedvirtual

This is a default handler for the signal signal_insert_child_anchor().

virtual void Gtk::TextBuffer::on_insert_pixbuf | ( | const TextBuffer::iterator& | pos,
|  | const Glib::RefPtr< Gdk::Pixbuf >& | pixbuf
| ) |  |

protectedvirtual

This is a default handler for the signal signal_insert_pixbuf().

virtual void Gtk::TextBuffer::on_mark_deleted | ( | const Glib::RefPtr< TextBuffer::Mark >& | mark | ) |

protectedvirtual

This is a default handler for the signal signal_mark_deleted().

virtual void Gtk::TextBuffer::on_mark_set | ( | const TextBuffer::iterator& | location,
|  | const Glib::RefPtr< TextBuffer::Mark >& | mark
| ) |  |

protectedvirtual

This is a default handler for the signal signal_mark_set().

virtual void Gtk::TextBuffer::on_modified_changed | ( |  | ) |

protectedvirtual

This is a default handler for the signal signal_modified_changed().

virtual void Gtk::TextBuffer::on_paste_done | ( | const Glib::RefPtr< Gtk::Clipboard >& | clipboard | ) |

protectedvirtual

This is a default handler for the signal signal_paste_done().

virtual void Gtk::TextBuffer::on_remove_tag | ( | const Glib::RefPtr< TextBuffer::Tag >& | tag,
|  | const TextBuffer::iterator& | range_begin,
|  | const TextBuffer::iterator& | range_end
| ) |  |

protectedvirtual

This is a default handler for the signal signal_remove_tag().

void Gtk::TextBuffer::paste_clipboard | ( | const Glib::RefPtr< Clipboard >& | clipboard,
|  | const iterator& | override_location,
|  | bool | default_editable = `true`
| ) |  |

void Gtk::TextBuffer::paste_clipboard | ( | const Glib::RefPtr< Clipboard >& | clipboard,
|  | bool | default_editable = `true`
| ) |  |

void Gtk::TextBuffer::place_cursor | ( | const iterator& | where | ) |

This function moves the "insert" and "selection_bound" marks simultaneously.

If you move them to the same place in two steps with move_mark(), you will temporarily select a region in between their old and new locations, which can be pretty inefficient since the temporarily-selected region will force stuff to be recalculated. This function moves them as a unit, which can be optimized.

Parameters:

  where | Where to put the cursor.

Glib::PropertyProxy_ReadOnly< int > Gtk::TextBuffer::property_cursor_position | ( |  | ) | const

The position of the insert mark (as offset from the beginning of the buffer).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextBuffer::property_has_selection | ( |  | ) | const

Whether the buffer has some text currently selected.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TextBuffer::TagTable> > Gtk::TextBuffer::property_tag_table | ( |  | ) | const

Text Tag Table.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::TextBuffer::property_text | ( |  | ) |

Current text of the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::TextBuffer::property_text | ( |  | ) | const

Current text of the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::ustring Gtk::TextBuffer::register_deserialize_tagset | ( | const Glib::ustring & | tagset_name | ) |

This function registers GTK+'s internal rich text serialization format with the passed buffer.

See register_serialize_tagset() for details.

Since gtkmm 2.10:

Parameters:

  tagset_name | An optional tagset name, on `0`.

Returns:
  The Gdk::Atom that corresponds to the newly registered format's mime-type.

Glib::ustring Gtk::TextBuffer::register_serialize_tagset | ( | const Glib::ustring & | tagset_name | ) |

This function registers GTK+'s internal rich text serialization format with the passed buffer.

The internal format does not comply to any standard rich text format and only works between Gtk::TextBuffer instances. It is capable of serializing all of a text buffer's tags and embedded pixbufs.

This function is just a wrapper around register_serialize_format(). The mime type used for registering is "application/x-gtk-text-buffer-rich-text", or "application/x-gtk-text-buffer-rich-text;format= @a tagset_name" if a tagset_name was passed.

The tagset_name can be used to restrict the transfer of rich text to buffers with compatible sets of tags, in order to avoid unknown tags from being pasted. It is probably the common case to pass an identifier != `0` here, since the `0` tagset requires the receiving buffer to deal with with pasting of arbitrary tags.

Since gtkmm 2.10:

Parameters:

  tagset_name | An optional tagset name, on `0`.

Returns:
  The Gdk::Atom that corresponds to the newly registered format's mime-type.

void Gtk::TextBuffer::remove_all_tags | ( | const iterator& | start,
|  | const iterator& | end
| ) |  |

Removes all tags in the range between start and end.

Be careful with this function; it could remove tags added in code unrelated to the code you're currently writing. That is, using this function is probably a bad idea if you have two or more unrelated code sections that add tags.

Parameters:

  start | One bound of range to be untagged.
  end | Other bound of range to be untagged.

void Gtk::TextBuffer::remove_selection_clipboard | ( | const Glib::RefPtr< Clipboard >& | clipboard | ) |

Removes a Gtk::Clipboard added with add_selection_clipboard().

Parameters:

  clipboard | A Gtk::Clipboard added to buffer by add_selection_clipboard().

void Gtk::TextBuffer::remove_tag | ( | const Glib::RefPtr< Tag >& | tag,
|  | const iterator& | start,
|  | const iterator& | end
| ) |  |

Emits the "remove-tag" signal.

The default handler for the signal removes all occurrences of tag from the given range. start and end don't have to be in order.

Parameters:

  tag | A Gtk::TextTag.
  start | One bound of range to be untagged.
  end | Other bound of range to be untagged.

void Gtk::TextBuffer::remove_tag_by_name | ( | const Glib::ustring & | name,
|  | const iterator& | start,
|  | const iterator& | end
| ) |  |

Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls remove_tag().

Parameters:

  name | Name of a Gtk::TextTag.
  start | One bound of range to be untagged.
  end | Other bound of range to be untagged.

void Gtk::TextBuffer::select_range | ( | const iterator& | ins,
|  | const iterator& | bound
| ) |  |

This function moves the "insert" and "selection_bound" marks simultaneously.

If you move them in two steps with move_mark(), you will temporarily select a region in between their old and new locations, which can be pretty inefficient since the temporarily-selected region will force stuff to be recalculated. This function moves them as a unit, which can be optimized.

Since gtkmm 2.4:

Parameters:

  ins | Where to put the "insert" mark.
  bound | Where to put the "selection_bound" mark.

void Gtk::TextBuffer::set_can_create_tags | ( | const Glib::ustring & | format,
|  | bool | can_create_tags = `true`
| ) |  |

Use this function to allow a rich text deserialization function to create new tags in the receiving buffer.

Note that using this function is almost always a bad idea, because the rich text functions you register should know how to map the rich text format they handler to your text buffers set of tags.

The ability of creating new (arbitrary!) tags in the receiving buffer is meant for special rich text formats like the internal one that is registered using register_deserialize_tagset(), because that format is essentially a dump of the internal structure of the source buffer, including its tag names.

You should allow creation of tags only if you know what you are doing, e.g. if you defined a tagset name for your application suite's text buffers and you know that it's fine to receive new tags from these buffers, because you know that your application can handle the newly created tags.

Since gtkmm 2.10:

Parameters:

  format | A Gdk::Atom representing a registered rich text format.
  can_create_tags | Whether deserializing this format may create tags.

void Gtk::TextBuffer::set_modified | ( | bool | setting = `true` | ) |

Used to keep track of whether the buffer has been modified since the last time it was saved.

Whenever the buffer is saved to disk, call gtk_text_buffer_set_modified ( buffer, `false`). When the buffer is modified, it will automatically toggled on the modified bit again. When the modified bit flips, the buffer emits a "modified-changed" signal.

Parameters:

  setting | Modification flag setting.

void Gtk::TextBuffer::set_text | ( | const Glib::ustring & | text | ) |

Removes the current contents of the buffer, and inserts text instead.

Parameters:

  text | The text to put in the buffer.

void Gtk::TextBuffer::set_text | ( | const char * | text_begin,
|  | const char * | text_end
| ) |  |

Removes the current contents of the buffer, and inserts text instead.

Parameters:

  text_begin | The start of a UTF8 character array.
  text_end | The end of the UTF8 character array.

Glib::SignalProxy3< void,const Glib::RefPtr<TextBuffer::Tag>&,const TextBuffer::iterator&,const TextBuffer::iterator& > Gtk::TextBuffer::signal_apply_tag | ( |  | ) |

Slot Prototype:
  `void on_my_apply_tag(const Glib::RefPtr<TextBuffer::Tag>& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)`

The signal_apply_tag() signal is emitted to apply a tag to a range of text in a Gtk::TextBuffer. Applying actually occurs in the default handler.

Note that if your handler runs before the default handler it must not invalidate the start and end iters (or has to revalidate them).

See also: Gtk::TextBuffer::apply_tag(), Gtk::TextBuffer::insert_with_tags(), Gtk::TextBuffer::insert_range().

Parameters:

  tag | The applied tag.
  start | The start of the range the tag is applied to.
  end | The end of the range the tag is applied to.

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_begin_user_action | ( |  | ) |

Slot Prototype:
  `void on_my_begin_user_action()`

The signal_begin_user_action() signal is emitted at the beginning of a single user-visible operation on a Gtk::TextBuffer.

See also: Gtk::TextBuffer::begin_user_action(), Gtk::TextBuffer::insert_interactive(), Gtk::TextBuffer::insert_range_interactive(), Gtk::TextBuffer::delete_interactive(), Gtk::TextBuffer::backspace(), Gtk::TextBuffer::delete_selection().

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_changed | ( |  | ) |

Slot Prototype:
  `void on_my_changed()`

The signal_changed() signal is emitted when the content of a Gtk::TextBuffer has changed.

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_end_user_action | ( |  | ) |

Slot Prototype:
  `void on_my_end_user_action()`

The signal_end_user_action() signal is emitted at the end of a single user-visible operation on the Gtk::TextBuffer.

See also: Gtk::TextBuffer::end_user_action(), Gtk::TextBuffer::insert_interactive(), Gtk::TextBuffer::insert_range_interactive(), Gtk::TextBuffer::delete_interactive(), Gtk::TextBuffer::backspace(), Gtk::TextBuffer::delete_selection(), Gtk::TextBuffer::backspace().

Glib::SignalProxy2< void,const TextBuffer::iterator&,const TextBuffer::iterator& > Gtk::TextBuffer::signal_erase | ( |  | ) |

Slot Prototype:
  `void on_my_erase(const TextBuffer::iterator& start, const TextBuffer::iterator& end)`

The signal_delete_range() signal is emitted to delete a range from a Gtk::TextBuffer.

Note that if your handler runs before the default handler it must not invalidate the start and end iters (or has to revalidate them). The default signal handler revalidates the start and end iters to both point point to the location where text was deleted. Handlers which run after the default handler (see Glib::signal_connect_after()) do not have access to the deleted text.

See also: Gtk::TextBuffer::delete().

Parameters:

  start | The start of the range to be deleted.
  end | The end of the range to be deleted.

Glib::SignalProxy3< void,const TextBuffer::iterator&,const Glib::ustring&,int > Gtk::TextBuffer::signal_insert | ( |  | ) |

Slot Prototype:
  `void on_my_insert(const TextBuffer::iterator& pos, const Glib::ustring& text, int bytes)`

The signal_insert_text() signal is emitted to insert text in a Gtk::TextBuffer. Insertion actually occurs in the default handler.

Note that if your handler runs before the default handler it must not invalidate the location iter (or has to revalidate it). The default signal handler revalidates it to point to the end of the inserted text.

See also: Gtk::TextBuffer::insert(), Gtk::TextBuffer::insert_range().

Parameters:

  location | Position to insert text in textbuffer.
  text | The UTF-8 text to be inserted.
  len | Length of the inserted text in bytes.

Glib::SignalProxy2< void,const TextBuffer::iterator&,const Glib::RefPtr<ChildAnchor>& > Gtk::TextBuffer::signal_insert_child_anchor | ( |  | ) |

Slot Prototype:
  `void on_my_insert_child_anchor(const TextBuffer::iterator& pos, const Glib::RefPtr<ChildAnchor>& anchor)`

The signal_insert_child_anchor() signal is emitted to insert a Gtk::TextChildAnchor in a Gtk::TextBuffer. Insertion actually occurs in the default handler.

Note that if your handler runs before the default handler it must not invalidate the location iter (or has to revalidate it). The default signal handler revalidates it to be placed after the inserted anchor.

See also: Gtk::TextBuffer::insert_child_anchor().

Parameters:

  location | Position to insert anchor in textbuffer.
  anchor | The Gtk::TextChildAnchor to be inserted.

Glib::SignalProxy2< void,const TextBuffer::iterator&,const Glib::RefPtr<Gdk::Pixbuf>& > Gtk::TextBuffer::signal_insert_pixbuf | ( |  | ) |

Slot Prototype:
  `void on_my_insert_pixbuf(const TextBuffer::iterator& pos, const Glib::RefPtr<Gdk::Pixbuf>& pixbuf)`

The signal_insert_pixbuf() signal is emitted to insert a Gdk::Pixbuf in a Gtk::TextBuffer. Insertion actually occurs in the default handler.

Note that if your handler runs before the default handler it must not invalidate the location iter (or has to revalidate it). The default signal handler revalidates it to be placed after the inserted pixbuf.

See also: Gtk::TextBuffer::insert_pixbuf().

Parameters:

  location | Position to insert pixbuf in textbuffer.
  pixbuf | The Gdk::Pixbuf to be inserted.

Glib::SignalProxy1< void,const Glib::RefPtr<TextBuffer::Mark>& > Gtk::TextBuffer::signal_mark_deleted | ( |  | ) |

Slot Prototype:
  `void on_my_mark_deleted(const Glib::RefPtr<TextBuffer::Mark>& mark)`

The signal_mark_deleted() signal is emitted as notification after a Gtk::TextMark is deleted.

See also: Gtk::TextBuffer::delete_mark().

Parameters:

  mark | The mark that was deleted.

Glib::SignalProxy2< void,const TextBuffer::iterator&,const Glib::RefPtr<TextBuffer::Mark>& > Gtk::TextBuffer::signal_mark_set | ( |  | ) |

Slot Prototype:
  `void on_my_mark_set(const TextBuffer::iterator& location, const Glib::RefPtr<TextBuffer::Mark>& mark)`

The signal_mark_set() signal is emitted as notification after a Gtk::TextMark is set.

See also: Gtk::TextBuffer::create_mark(), Gtk::TextBuffer::move_mark().

Parameters:

  location | The location of mark in textbuffer.
  mark | The mark that is set.

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_modified_changed | ( |  | ) |

Slot Prototype:
  `void on_my_modified_changed()`

The signal_modified_changed() signal is emitted when the modified bit of a Gtk::TextBuffer flips.

See also: Gtk::TextBuffer::set_modified().

Glib::SignalProxy1< void,const Glib::RefPtr<Gtk::Clipboard>& > Gtk::TextBuffer::signal_paste_done | ( |  | ) |

Slot Prototype:
  `void on_my_paste_done(const Glib::RefPtr<Gtk::Clipboard>& clipboard)`

The paste-done signal is emitted after paste operation has been completed. This is useful to properly scroll the view to the end of the pasted text. See Gtk::TextBuffer::paste_clipboard() for more details.

Since gtkmm 2.16:

Glib::SignalProxy3< void,const Glib::RefPtr<TextBuffer::Tag>&,const TextBuffer::iterator&,const TextBuffer::iterator& > Gtk::TextBuffer::signal_remove_tag | ( |  | ) |

Slot Prototype:
  `void on_my_remove_tag(const Glib::RefPtr<TextBuffer::Tag>& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)`

The signal_remove_tag() signal is emitted to remove all occurrences of tag from a range of text in a Gtk::TextBuffer. Removal actually occurs in the default handler.

Note that if your handler runs before the default handler it must not invalidate the start and end iters (or has to revalidate them).

See also: Gtk::TextBuffer::remove_tag().

Parameters:

  tag | The tag to be removed.
  start | The start of the range the tag is removed from.
  end | The end of the range the tag is removed from.

int Gtk::TextBuffer::size | ( |  | ) | const

See get_char_count().

void Gtk::TextBuffer::unregister_deserialize_format | ( | const Glib::ustring & | format | ) |

This function unregisters a rich text format that was previously registered using register_deserialize_format() or register_deserialize_tagset().

Since gtkmm 2.10:

Parameters:

  format | A Gdk::Atom representing a registered rich text format.

void Gtk::TextBuffer::unregister_serialize_format | ( | const Glib::ustring & | format | ) |

This function unregisters a rich text format that was previously registered using register_serialize_format() or register_serialize_tagset()

Since gtkmm 2.10:

Parameters:

  format | A Gdk::Atom representing a registered rich text format.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::TextBuffer > wrap | ( | GtkTextBuffer * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/textbuffer.h